﻿using Microsoft.Xaml.Behaviors;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SelectionDemo
{
    public class SfDataGridBehavior:Behavior<SfDataGrid>
    {
        SfDataGrid dataGrid = null;
        bool isRighClickButtonEnabled = false;
        protected override void OnAttached()
        {
            base.OnAttached();
            this.dataGrid = this.AssociatedObject as SfDataGrid;
            this.dataGrid.CellTapped += DataGrid_CellTapped;
            this.dataGrid.CurrentCellBeginEdit += DataGrid_CurrentCellBeginEdit;

        }

        private void DataGrid_CurrentCellBeginEdit(object sender, CurrentCellBeginEditEventArgs e)
        {
            if (isRighClickButtonEnabled)
                e.Cancel = true;
        }

        private void DataGrid_CellTapped(object sender, GridCellTappedEventArgs e)
        {
            if(e.ChangedButton == System.Windows.Input.MouseButton.Right)
            {
                isRighClickButtonEnabled = true;
            }
            else
            {
                isRighClickButtonEnabled = false;
            }
        }
    }
}
