﻿using SelectionDemo.Model;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace SelectionDemo
{
    class ViewModel : INotifyPropertyChanged
    {
        EmployeeDetails emp = new EmployeeDetails();

        #region Constructor

        public ViewModel()
        {
            this.ItemsCollection = emp;
        }

        #endregion


        private ObservableCollection<BusinessObjects> itemsCollection;
        public ObservableCollection<BusinessObjects> ItemsCollection
        {
            get
            {
                return itemsCollection;
            }
            set
            {
                itemsCollection = value;
                OnPropertyChanged("GDCSource");
            }
        }

        private Columns _columns;
        public Columns Columns
        {
            get
            {
                if (_columns == null)
                    _columns = GetColumns();
                return _columns;
            }
            set
            {
                this._columns = value;
                OnPropertyChanged("Columns");
            }
        }

        protected Columns GetColumns()
        {
            Columns _columns = new Columns();

            var col1 = new GridTextColumn() { MappingName = "EmployeeName" };
            var col2 = new GridTextColumn() { MappingName = "EmployeeAge" };
            var col3 = new GridTextColumn() { MappingName = "EmployeeSalary" };
            var col4 = new GridTextColumn() { MappingName = "ExperienceInMonth" };

            _columns.Add(col1);
            _columns.Add(col2);
            _columns.Add(col3);
            _columns.Add(col4);

            return _columns;
        }


        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

    }

    class EmployeeDetails : ObservableCollection<BusinessObjects>
    {
        Random rand = new Random();
        public EmployeeDetails()
        {
            PopulateCollection();
        }

        private void PopulateCollection()
        {
            this.Clear();

            BusinessObjects b = new BusinessObjects() { IsChecked = false, EmployeeName = "Mart", CountryCode = "NR", EmployeeAge = 34, EmployeeArea = "101010", EmployeeSalary = 1.7, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { IsChecked = false, EmployeeName = "Peter", CountryCode = "NP", EmployeeAge = 43, EmployeeArea = "010101", EmployeeSalary = 2.5, ExperienceInMonth = 45, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { IsChecked = false, EmployeeName = "James", CountryCode = "NL", EmployeeAge = 42, EmployeeArea = "1222111", EmployeeSalary = 18700, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { IsChecked = false, EmployeeName = "Oliver", CountryCode = "NZ", EmployeeAge = 36, EmployeeArea = "011111", EmployeeSalary = 67000, ExperienceInMonth = 17, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { IsChecked = false, EmployeeName = "Robert", CountryCode = "NI", EmployeeAge = 54, EmployeeArea = "111111", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { IsChecked = false, EmployeeName = "Suji", CountryCode = "NE", EmployeeAge = 45, EmployeeArea = "11111111", EmployeeSalary = 90000, ExperienceInMonth = 14, EmployeeGender = "Female", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { IsChecked = false, EmployeeName = "Mahesh", CountryCode = "NG", EmployeeAge = 48, EmployeeArea = "111111111", EmployeeSalary = 34567, ExperienceInMonth = 20, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
        }
    }
}
